"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var accordion_component_1 = require('./accordion.component');
var animationTime = 300;
var AccordComponent = (function () {
    function AccordComponent(accordionComp) {
        this.accordionComp = accordionComp;
        this.title = 'Accord';
        this.locked = false;
        this.act = false;
        this.inner = 'closed';
        this.hasOverflow = true;
        accordionComp.addAccord(this);
    }
    Object.defineProperty(AccordComponent.prototype, "active", {
        set: function (act) {
            this.act = act;
            this.hasOverflow = !act;
            this.inner = act ? 'open' : 'closed';
        },
        enumerable: true,
        configurable: true
    });
    ;
    AccordComponent.prototype.trigger = function () {
        var _this = this;
        this.hasOverflow = true;
        setTimeout(function () { return _this.hasOverflow = _this.inner === 'closed'; }, animationTime);
        this.accordionComp.trigger(this);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AccordComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AccordComponent.prototype, "locked", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean), 
        __metadata('design:paramtypes', [Boolean])
    ], AccordComponent.prototype, "active", null);
    AccordComponent = __decorate([
        core_1.Component({
            selector: 'sc-accord',
            template: "\n        <div class=\"accord\" [class.active]=\"act\">\n            <div class=\"bar\" (click)=\"trigger()\">\n                <span>{{title}}</span>\n            </div>\n            <div class=\"inner\" [@anim]=\"inner\" [ngClass]=\"{closed: hasOverflow || inner === 'closed'}\">\n                <div class=\"pad\">\n                    <ng-content></ng-content>\n                </div>\n            </div>\n        </div>\n    ",
            animations: [
                core_1.trigger('anim', [
                    core_1.state('open', core_1.style({ height: '*' })),
                    core_1.state('closed', core_1.style({ height: 0 })),
                    core_1.transition('closed <=> open', core_1.animate(animationTime + "ms ease-in-out"))
                ])
            ],
            styles: ["  \n        .bar {\n            width: 100%;\n            height: 50px;\n            border-bottom: 1px solid rgba(0, 0, 0, 0.12);\n            border-top: 1px solid rgba(0, 0, 0, 0.12);\n            cursor: pointer;\n            background: #fff;\n            user-select: none;\n            -webkit-touch-callout: none;\n            -webkit-user-select: none; \n            -moz-user-select: none\n        }\n        \n        span {\n            line-height: 50px;\n            padding: 0 1rem;\n            font-size: 1.1rem;\n            text-transform: uppercase;\n        }\n        \n        .inner {\n            display: block;\n            background: #F6F6F6;\n        }\n        \n        .inner.closed {\n            overflow: hidden;\n        }\n        \n        .pad {\n            padding: 0.5rem 1rem;\n        }\n    "]
        }), 
        __metadata('design:paramtypes', [accordion_component_1.AccordionComponent])
    ], AccordComponent);
    return AccordComponent;
}());
exports.AccordComponent = AccordComponent;
//# sourceMappingURL=accord.component.js.map