"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var BlockSliderComponent = (function () {
    function BlockSliderComponent() {
        this.blockCount = 4;
        this.startingPosition = 0;
        this.gap = 2;
        this.initialCount = 4;
        this.blocks = [];
        this.position = 0;
        this.positionStyle = '0';
    }
    Object.defineProperty(BlockSliderComponent.prototype, "mediaQuery", {
        set: function (m) {
            this._mediaSorted = m.sort(function (a, b) { return a.screenWidth - b.screenWidth; });
        },
        enumerable: true,
        configurable: true
    });
    BlockSliderComponent.prototype.screenResize = function (event) {
        if (this._mediaSorted) {
            var found = this._mediaSorted.findIndex(function (a) { return a.screenWidth > event.target.innerWidth; });
            this.blockCount = found !== -1 ? this._mediaSorted[found].blockCount : this.initialCount;
            var width_1 = this.blockWidth();
            this.blocks.forEach(function (a) { return a.width = width_1; });
            this.positionStyle = "-" + this.position * width_1 + "%";
        }
    };
    BlockSliderComponent.prototype.ngOnInit = function () {
        this.position = this.startingPosition;
        this.positionStyle = "-" + this.position * this.blockWidth() + "%";
        this.initialCount = this.blockCount;
    };
    BlockSliderComponent.prototype.blockWidth = function () {
        return (100 - this.gap * this.blockCount) / this.blockCount;
    };
    BlockSliderComponent.prototype.blockWidthWithGap = function () {
        return 100 / this.blockCount;
    };
    BlockSliderComponent.prototype.addBlock = function (block) {
        this.blocks.push(block);
        this._segments = this.blocks.length / this.blockCount;
        this._lastSegment = [(this._segments - 1) * this.blockCount, this._segments * this.blockCount];
    };
    BlockSliderComponent.prototype.moveLeft = function () {
        var _this = this;
        if (!this.position)
            this.position = this._lastSegment[0];
        else
            this.position--;
        this.blocks.forEach(function (a, i) { return a.active = _this.calcActive(i); });
        this.positionStyle = "-" + this.position * this.blockWidthWithGap() + "%";
    };
    BlockSliderComponent.prototype.moveRight = function () {
        var _this = this;
        if (this.position >= this._lastSegment[0] && this.position <= this._lastSegment[1])
            this.position = 0;
        else
            this.position++;
        this.blocks.forEach(function (a, i) { return a.active = _this.calcActive(i); });
        this.positionStyle = "-" + this.position * this.blockWidthWithGap() + "%";
    };
    BlockSliderComponent.prototype.onSwipe = function (event) {
        if (event.deltaX > 0)
            this.moveLeft();
        else
            this.moveRight();
    };
    BlockSliderComponent.prototype.calcActive = function (index) {
        return index >= this.position && index < this.position + this.blockCount;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], BlockSliderComponent.prototype, "blockCount", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], BlockSliderComponent.prototype, "startingPosition", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], BlockSliderComponent.prototype, "gap", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array), 
        __metadata('design:paramtypes', [Array])
    ], BlockSliderComponent.prototype, "mediaQuery", null);
    __decorate([
        core_1.HostListener('window:resize', ['$event']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], BlockSliderComponent.prototype, "screenResize", null);
    BlockSliderComponent = __decorate([
        core_1.Component({
            selector: 'sc-block-slider',
            styles: ["\n        :host {\n            display: block;\n        }\n        \n        .arrow {\n            height: 100%;\n            position: absolute;\n            width: 5%;\n            top: 0;\n            cursor: pointer;\n        }\n        \n        .arrow.right {\n            right: 0;\n            border-left: 1px solid rgba(0, 0, 0, 0.12);\n        }\n       .arrow.left {\n            left: 0;\n            border-right: 1px solid rgba(0, 0, 0, 0.12);\n        } \n        \n        .arrow .line {\n            position: absolute;\n            top: 50%;\n            width: 3px;\n            height: 14px;\n            transform-origin: 50% 0;\n        }\n        \n        .arrow.right .line { \n            transform: rotate(45deg);\n            left: 60%;\n        }\n        .arrow.right .line:nth-child(2) { transform: translateY(1px) rotate(135deg) }\n        \n        .arrow.left .line { \n            transform: rotate(-45deg);\n            right: 60%;\n        }\n        .arrow.left .line:nth-child(2) { transform: translateY(1px) rotate(-135deg) }\n        \n        .arrow .line:after {\n            content: \"\";\n            position: absolute;\n            left: 0;\n            top: 0;\n            width: 100%;\n            height: 100%;\n            background-color: #888;\n            transition: background-color 0.3s;\n        }       \n       \n        .slide-wrapper {\n            display: block;\n            white-space: nowrap;\n            transition: all .3s ease;\n        }\n    "],
            template: "\n        <div class=\"arrow right\" (click)=\"moveRight()\">\n            <span class=\"line\"></span>    \n            <span class=\"line\"></span>    \n        </div>\n        <div class=\"arrow left\" (click)=\"moveLeft()\">\n            <span class=\"line\"></span>    \n            <span class=\"line\"></span>    \n        </div>\n        <div class=\"slide-wrapper\"[ngStyle]=\"{'transform': 'translate3d(' + positionStyle + ', 0, 0'}\" (swipe)=\"onSwipe($event)\">\n            <ng-content></ng-content>\n        </div>\n    "
        }), 
        __metadata('design:paramtypes', [])
    ], BlockSliderComponent);
    return BlockSliderComponent;
}());
exports.BlockSliderComponent = BlockSliderComponent;
//# sourceMappingURL=block-slider.component.js.map