"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var window_1 = require('../../utils/window/window');
var MorphOverlayComponent = (function () {
    function MorphOverlayComponent(_el, _window) {
        this._el = _el;
        this._window = _window;
        this.overlayBg = '#F44336';
        this.initialDelay = 300;
        this.modalTitle = '';
        this.overflowBody = true;
        this.blockHidden = true;
        this.modalHidden = true;
        this.triggerActive = false;
        this.scaleX = 1;
        this.scaleY = 1;
    }
    Object.defineProperty(MorphOverlayComponent.prototype, "style", {
        get: function () {
            return {
                visibility: this.blockHidden ? 'hidden' : 'visible',
                background: this.overlayBg,
                width: this.width + "px",
                height: this.height + "px",
                top: "0px",
                left: "0px",
                transform: "scaleX(" + this.scaleX + ") scaleY(" + this.scaleY + ")"
            };
        },
        enumerable: true,
        configurable: true
    });
    MorphOverlayComponent.prototype.open = function () {
        var _this = this;
        var rect = this._el.nativeElement.getBoundingClientRect();
        this.width = rect.width;
        this.height = rect.height;
        this.left = rect.left;
        this.top = rect.top;
        this.triggerActive = true;
        if (this._window.document && this.overflowBody)
            this._window.document.body.style.overflowY = 'hidden';
        setTimeout(function () {
            _this.blockHidden = false;
            _this.scaleY = _this._calcScale(_this.top, _this.height, _this._window.innerHeight);
            _this.scaleX = _this._calcScale(_this.left, _this.width, _this._window.innerWidth);
            setTimeout(function () {
                _this.blockHidden = true;
                _this.modalHidden = false;
            }, 500);
        }, this.initialDelay);
    };
    MorphOverlayComponent.prototype.close = function () {
        var _this = this;
        this.blockHidden = false;
        this.modalHidden = true;
        this.scaleX = 1;
        this.scaleY = 1;
        if (this._window.document && this.overflowBody)
            this._window.document.body.style.overflowY = 'initial';
        setTimeout(function () {
            _this.blockHidden = true;
            _this.triggerActive = false;
        }, 500);
    };
    MorphOverlayComponent.prototype._calcScale = function (firstCoord, elSize, windowSize) {
        var secondCoord = windowSize - firstCoord - elSize, maxCoord = Math.max(firstCoord, secondCoord), scaleValue = (maxCoord * 2 + elSize) / elSize;
        return Math.ceil(scaleValue * 10) / 10;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], MorphOverlayComponent.prototype, "overlayBg", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], MorphOverlayComponent.prototype, "initialDelay", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], MorphOverlayComponent.prototype, "modalTitle", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], MorphOverlayComponent.prototype, "overflowBody", void 0);
    __decorate([
        core_1.ContentChild('scTrigger'), 
        __metadata('design:type', core_1.TemplateRef)
    ], MorphOverlayComponent.prototype, "triggerRef", void 0);
    __decorate([
        core_1.ContentChild('scContent'), 
        __metadata('design:type', core_1.TemplateRef)
    ], MorphOverlayComponent.prototype, "contentRef", void 0);
    MorphOverlayComponent = __decorate([
        core_1.Component({
            selector: 'sc-morph-overlay',
            styles: ["\n\n        :host {\n            display: block;\n            width: 200px;\n            height: 200px;\n            margin-top: 200px;\n            margin-left: 300px;\n            position: relative;\n        }\n\n        .modal {\n            position: fixed;\n            top: 0;\n            left: 0;\n            height: 100%;\n            width: 100%;\n        }\n        \n        .animation-block {\n            position: absolute;\n            top: 0;\n            left: 0;\n            transition: transform 500ms ease-in-out;\n        }\n    "],
            template: "\n        <div class=\"trigger\" [ngClass]=\"{active: triggerActive}\" (click)=\"open()\">\n            <template [ngTemplateOutlet]=\"triggerRef\"></template>\n        </div>\n        <span class=\"animation-block\" [ngStyle]=\"style\"></span>\n        <div class=\"modal\" [ngClass]=\"{active: !modalHidden}\" [ngStyle]=\"{background: overlayBg}\" [hidden]=\"modalHidden\">\n            <div class=\"modal__header\">\n                <h3>{{modalTitle}}</h3>\n                <button (click)=\"close()\" class=\"close\">Close</button>\n            </div>\n            <template [ngTemplateOutlet]=\"contentRef\"></template>\n        </div>    \n    "
        }),
        __param(1, core_1.Inject(window_1.Window)), 
        __metadata('design:paramtypes', [core_1.ElementRef, Object])
    ], MorphOverlayComponent);
    return MorphOverlayComponent;
}());
exports.MorphOverlayComponent = MorphOverlayComponent;
//# sourceMappingURL=morph-overlay.component.js.map