"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var window_1 = require('../../utils/window/window');
var ScrollAnimationDirective = (function () {
    function ScrollAnimationDirective(_el, _renderer, _window) {
        this._el = _el;
        this._renderer = _renderer;
        this._window = _window;
        this.windowHeight = this._window.innerHeight;
        this.hasClass = false;
        this.options = {
            ref: this._el,
            offset: 0,
            class: 'enter',
            delay: 0,
            hideInitial: true,
            removeAfter: null
        };
    }
    Object.defineProperty(ScrollAnimationDirective.prototype, "sc", {
        set: function (options) {
            this.options = Object.assign(this.options, options);
        },
        enumerable: true,
        configurable: true
    });
    ScrollAnimationDirective.prototype.onScroll = function () {
        var _this = this;
        if (!this.hasClass && this._window.pageYOffset + this.windowHeight >= this.top + this.options.offset) {
            setTimeout(function () {
                _this._renderer.setElementClass(_this._el.nativeElement, _this.options.class, true);
                if (_this.options.removeAfter !== null)
                    setTimeout(function () { return _this._renderer.setElementClass(_this._el.nativeElement, _this.options.class, false); }, _this.options.removeAfter);
            }, this.options.delay);
            this.hasClass = true;
        }
    };
    ScrollAnimationDirective.prototype.onResize = function () {
        this.windowHeight = this._window.innerHeight;
        this._setTop();
    };
    ScrollAnimationDirective.prototype.ngOnInit = function () {
        if (this.options.hideInitial)
            this._hideInitial();
        this._setTop();
        this.onScroll();
    };
    ScrollAnimationDirective.prototype._setTop = function () {
        this.top = this.options.ref.nativeElement.getBoundingClientRect ? this.options.ref.nativeElement.getBoundingClientRect().top : 0;
    };
    ScrollAnimationDirective.prototype._hideInitial = function () {
        this._renderer.setElementStyle(this._el.nativeElement, 'opacity', '0');
    };
    __decorate([
        core_1.Input('sc-animation'), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], ScrollAnimationDirective.prototype, "sc", null);
    __decorate([
        core_1.HostListener('window:scroll'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ScrollAnimationDirective.prototype, "onScroll", null);
    __decorate([
        core_1.HostListener('window:resize'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ScrollAnimationDirective.prototype, "onResize", null);
    ScrollAnimationDirective = __decorate([
        core_1.Directive({ selector: '[sc-animation]' }),
        __param(2, core_1.Inject(window_1.Window)), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.Renderer, Object])
    ], ScrollAnimationDirective);
    return ScrollAnimationDirective;
}());
exports.ScrollAnimationDirective = ScrollAnimationDirective;
//# sourceMappingURL=scroll-animation.directive.js.map