"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var animationTime = 200;
var ModalComponent = (function () {
    function ModalComponent(_comp) {
        this._comp = _comp;
        this.doClose = new core_1.EventEmitter();
        this.state = 'open';
    }
    ModalComponent.prototype.createWithComp = function (modal, comp) {
        var _this = this;
        this._comp.compileModuleAndAllComponentsAsync(modal).then(function (res) {
            var ref = _this.wrapperRef.createComponent(res.componentFactories.find(function (a) { return a.componentType === comp; }));
            if (_this.toSet) {
                var keys = Object.keys(_this.toSet);
                keys.forEach(function (a) { return ref.instance[a] = _this.toSet[a]; });
            }
        });
    };
    ModalComponent.prototype.overlayClose = function () {
        if (this.settings.overlayClickToClose)
            this.close();
    };
    ModalComponent.prototype.close = function () {
        var _this = this;
        this.state = 'void';
        setTimeout(function () { return _this.doClose.emit(true); }, animationTime);
    };
    __decorate([
        core_1.ViewChild('wrapper', { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.ViewContainerRef)
    ], ModalComponent.prototype, "wrapperRef", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ModalComponent.prototype, "doClose", void 0);
    ModalComponent = __decorate([
        core_1.Component({
            selector: 'sc-modal',
            styles: ["\n    \n        :host {\n            display: block;\n        }\n\n        .overlay {\n            position: fixed;\n            top: 0;\n            left: 0;\n            width: 100%;\n            height: 100%;\n            background: rgba(0, 0, 0, 0.6);\n        }\n        \n        .wrapper {\n            position: fixed;\n            top: 0;\n            bottom: 0;\n            left: 0;\n            right: 0;\n            padding: 1rem;\n            margin: auto;\n            width: 200px;\n            height: 200px;\n            background: #fff;\n            box-shadow: 0 2px 5px 0 rgba(0,0,0,0.16),0 2px 10px 0 rgba(0,0,0,0.12);\n        }\n        \n        .close {\n            position: absolute;\n            border: none;\n            top: -25px;\n            right: -25px;\n            width: 50px;\n            height: 50px;\n            background: #333;\n            border-radius: 50%;\n            box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);\n            transition: all 0.3s cubic-bezier(.25,.8,.25,1);\n            cursor: pointer;\n            outline: none;\n        }\n        \n        .close:hover {\n            box-shadow: 0 14px 28px rgba(0,0,0,0.25), 0 10px 10px rgba(0,0,0,0.22);\n        }\n        \n        .close .ex-close {\n            position: relative;\n            display: inline-block;\n            width: 20px;\n            height: 20px;\n            overflow: hidden;\n            padding: 0;\n        }\n        \n        .close .ex-close::before,\n        .close .ex-close::after {\n            content: '';\n            position: absolute;\n            height: 4px;\n            width: 100%;\n            top: 50%;\n            left: 0;\n            margin-top: -1px;\n            background: #fff;\n            border-radius: 5px;\n        }\n        \n        .close .ex-close::before { transform: rotate(45deg) }\n        .close .ex-close::after { transform: rotate(-45deg) }\n    "],
            animations: [
                core_1.trigger('overlay', [
                    core_1.state('void', core_1.style({ opacity: 0 })),
                    core_1.state('open', core_1.style({ opacity: 1 })),
                    core_1.transition('void <=> open', core_1.animate(animationTime + "ms ease-in-out"))
                ]),
                core_1.trigger('wrapper', [
                    core_1.state('void', core_1.style({ opacity: 0, transform: 'translateY(20%)' })),
                    core_1.state('open', core_1.style({ opacity: 1, transform: 'translateY(0)' })),
                    core_1.transition('void <=> open', core_1.animate(animationTime + "ms ease-in-out"))
                ])
            ],
            template: "\n        <div class=\"overlay\"  [@overlay]=\"state\" (click)=\"overlayClose()\"></div>\n        <div class=\"wrapper\" [@wrapper]=\"state\">\n            <button class=\"close\" *ngIf=\"settings.showCloseButton\" (click)=\"close()\">\n                <span class=\"ex-close\"></span>\n            </button>\n            <div #wrapper></div>\n        </div>\n    "
        }), 
        __metadata('design:paramtypes', [core_1.Compiler])
    ], ModalComponent);
    return ModalComponent;
}());
exports.ModalComponent = ModalComponent;
//# sourceMappingURL=modal.component.js.map