"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var animationTime = 300;
var SelectComponent = (function () {
    function SelectComponent(_eref) {
        this._eref = _eref;
        this.animationState = 'closed';
        this.opening = false;
        this.itemsToDisplay = [];
        this.itemsOriginal = [];
        this.topPosition = '0';
        this.selected = null;
        this.selectedChange = new core_1.EventEmitter();
        this.placeholder = null;
        this.maxHeight = 250;
        this.state = new core_1.EventEmitter();
    }
    Object.defineProperty(SelectComponent.prototype, "items", {
        set: function (it) {
            this.itemsOriginal = it;
            this._createDisplay();
        },
        enumerable: true,
        configurable: true
    });
    ;
    SelectComponent.prototype.outsideClick = function (target) {
        if (!this._eref.nativeElement.contains(target) && this.animationState === 'open')
            this.toggle();
    };
    ;
    Object.defineProperty(SelectComponent.prototype, "style", {
        get: function () { return { 'max-height': this.maxHeight + 'px', 'overflow': this.opening ? 'hidden' : 'auto' }; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "inSelected", {
        get: function () {
            if (this.selected)
                return 'selected';
            if (this.placeholderRef)
                return 'placeholderRef';
            if (this.placeholder)
                return 'placeholder';
            return 'none';
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.select = function (index) {
        this.selected = this.itemsToDisplay[index];
        this.selectedChange.emit(this.selected);
        this._createDisplay(index);
        this.toggle();
    };
    SelectComponent.prototype.toggle = function () {
        var _this = this;
        this.opening = true;
        this.animationState = this.animationState === 'closed' ? 'open' : 'closed';
        setTimeout(function () { return _this.opening = false; }, animationTime);
        this.state.emit(this.animationState);
    };
    SelectComponent.prototype._createDisplay = function (index) {
        this.itemsToDisplay = this.itemsOriginal;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], SelectComponent.prototype, "selected", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], SelectComponent.prototype, "selectedChange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], SelectComponent.prototype, "items", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SelectComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], SelectComponent.prototype, "maxHeight", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], SelectComponent.prototype, "state", void 0);
    __decorate([
        core_1.ViewChild('selection'), 
        __metadata('design:type', Object)
    ], SelectComponent.prototype, "selectionEL", void 0);
    __decorate([
        core_1.ContentChild('scListItem'), 
        __metadata('design:type', core_1.TemplateRef)
    ], SelectComponent.prototype, "selectRef", void 0);
    __decorate([
        core_1.ContentChild('scPlaceholder'), 
        __metadata('design:type', core_1.TemplateRef)
    ], SelectComponent.prototype, "placeholderRef", void 0);
    __decorate([
        core_1.HostListener('document:click', ['$event.target']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], SelectComponent.prototype, "outsideClick", null);
    SelectComponent = __decorate([
        core_1.Component({
            encapsulation: core_1.ViewEncapsulation.None,
            selector: 'sc-select',
            animations: [
                core_1.trigger('select', [
                    core_1.state('closed', core_1.style({ height: 0 })),
                    core_1.state('open', core_1.style({ height: '*' })),
                    core_1.transition('closed <=> open', core_1.animate(animationTime + "ms cubic-bezier(.17,.67,0,1)"))
                ])
            ],
            styles: ["\n        :host {\n            display: block;\n            cursor: pointer;\n            position: relative;\n            width: 200px;\n            background: #fff;\n            box-shadow: 0 2px 5px 0 rgba(0,0,0,0.16),0 2px 10px 0 rgba(0,0,0,0.12);\n        }\n        \n        .selected .ph {\n            text-align: center;\n            margin: 0;\n            padding: 0.5rem 1rem;\n            font-size: 1.1rem;\n        }\n        \n        .selected .wp {\n            padding: 0.5rem 1rem;\n        }\n        \n        .selection {\n            position: absolute;\n            width: 100%;\n            background: #fff;\n            top: 100%;\n            box-shadow: 0 2px 5px 0 rgba(0,0,0,0.16),0 2px 10px 0 rgba(0,0,0,0.12);\n        }\n        \n        .selection.active { border-top: 1px dashed #ccc; }\n        .item { padding: 0.5rem 1rem; }\n    "],
            template: "\n        <div class=\"selected\" [ngSwitch]=\"inSelected\" (click)=\"toggle()\">\n            <div *ngSwitchCase=\"'selected'\" class=\"wp\"><template [ngTemplateOutlet]=\"selectRef\" [ngOutletContext]=\"{item: selected, index: -1}\"></template></div>\n            <div *ngSwitchCase=\"'placeholderRef'\" class=\"wp\"><template [ngTemplateOutlet]=\"placeholderRef\"></template></div>\n            <p *ngSwitchCase=\"'placeholder'\" class=\"ph\">{{placeholder}}</p>   \n            <p *ngSwitchCase=\"'none'\" class=\"ph\">Select Something</p>                    \n        </div>\n        <div class=\"selection\" #selection  [@select]=\"animationState\" [ngStyle]=\"style\" [class.active]=\"animationState === 'open'\">\n            <div class=\"item\" *ngFor=\"let item of itemsToDisplay; let i = index\" (click)=\"select(i)\">\n                <template [ngTemplateOutlet]=\"selectRef\" [ngOutletContext]=\"{item: item, index: i}\"></template>\n            </div>\n        </div>\n    "
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef])
    ], SelectComponent);
    return SelectComponent;
}());
exports.SelectComponent = SelectComponent;
//# sourceMappingURL=select.component.js.map