"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var tabs_component_1 = require('./tabs.component');
var TabComponent = (function () {
    function TabComponent(tabsComp, _el) {
        this.tabsComp = tabsComp;
        this._el = _el;
        this.title = 'Tab';
        this.disabled = false;
        this.act = false;
        this.animate = 'default';
    }
    Object.defineProperty(TabComponent.prototype, "zIndex", {
        get: function () {
            return this.act ? 10 : 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabComponent.prototype, "active", {
        set: function (act) {
            var _this = this;
            this.act = act;
            if (act) {
                setTimeout(function () { return _this.animate = 'first'; }, 0);
                this.tabsComp.setStyle(this._el.nativeElement.offsetHeight);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    TabComponent.prototype.ngOnInit = function () {
        this.height = this._el.nativeElement.offsetHeight;
        this.position = this.tabsComp.tabs.length;
        this.tabsComp.addTab(this);
    };
    __decorate([
        core_1.HostBinding('style.z-index'), 
        __metadata('design:type', Object)
    ], TabComponent.prototype, "zIndex", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean), 
        __metadata('design:paramtypes', [Boolean])
    ], TabComponent.prototype, "active", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TabComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], TabComponent.prototype, "disabled", void 0);
    TabComponent = __decorate([
        core_1.Component({
            selector: 'sc-tab',
            template: "\n      <ng-content></ng-content>\n    ",
            host: {
                '[@anim]': 'animate'
            },
            animations: [
                core_1.trigger('anim', [
                    core_1.state('default', core_1.style({ position: 'absolute', opacity: 0 })),
                    core_1.state('first', core_1.style({ position: 'relative', opacity: 1 })),
                    core_1.state('leaveLeft', core_1.style({ position: 'absolute', opacity: 0 })),
                    core_1.state('leaveRight', core_1.style({ position: 'absolute', opacity: 0 })),
                    core_1.state('enterRight', core_1.style({ position: 'relative', opacity: 1 })),
                    core_1.state('enterLeft', core_1.style({ position: 'relative', opacity: 1 })),
                    core_1.transition('* => enterRight', [
                        core_1.style({ transform: 'translateX(-100%)', opacity: 0 }),
                        core_1.animate('300ms ease-in-out', core_1.style({ transform: 'translateX(0)', opacity: 1 }))
                    ]),
                    core_1.transition('* => enterLeft', [
                        core_1.style({ transform: 'translateX(100%)', opacity: 0 }),
                        core_1.animate('300ms ease-in-out', core_1.style({ transform: 'translateX(0)', opacity: 1 }))
                    ]),
                    core_1.transition('* => leaveLeft', [
                        core_1.style({ transform: 'translateX(0)', opacity: 1 }),
                        core_1.animate('300ms ease-in-out', core_1.style({ transform: 'translateX(-100%)', opacity: 0 }))
                    ]),
                    core_1.transition('* => leaveRight', [
                        core_1.style({ transform: 'translateX(0)', opacity: 1 }),
                        core_1.animate('300ms ease-in-out', core_1.style({ transform: 'translateX(100%)', opacity: 0 }))
                    ]),
                ])
            ],
            styles: ["\n        :host {\n            display: block;\n            top: 0;\n            left: 0;\n            right: 0;\n            bottom: 0;\n            padding: 1rem;\n        }\n    "]
        }), 
        __metadata('design:paramtypes', [tabs_component_1.TabsComponent, core_1.ElementRef])
    ], TabComponent);
    return TabComponent;
}());
exports.TabComponent = TabComponent;
//# sourceMappingURL=tab.component.js.map