"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var TabsComponent = (function () {
    function TabsComponent() {
        this.tabs = [];
    }
    TabsComponent.prototype.selectTab = function (tab) {
        if (tab.disabled)
            return;
        var oldActive = this.tabs.findIndex(function (a) { return a.act; }), direction = tab.position > oldActive ? 'Left' : 'Right';
        this.tabs.forEach(function (tab) { return tab.act = false; });
        tab.act = true;
        if (oldActive !== tab.position) {
            tab.animate = 'enter' + direction;
            this.tabs[oldActive].animate = 'leave' + direction;
        }
        this.setStyle(tab.height);
    };
    TabsComponent.prototype.setStyle = function (tabHeight) {
        this.style = { height: tabHeight + "px" };
    };
    TabsComponent.prototype.addTab = function (tab) {
        this.tabs.push(tab);
    };
    TabsComponent.prototype.indicatorStyle = function () {
        var active = this.tabs.findIndex(function (a) { return a.act; }), percent = 100 / this.tabs.length, style = { width: percent + '%' };
        if (active) {
            if (active === this.tabs.length)
                style['right'] = 0;
            else
                style['left'] = percent * active + '%';
        }
        else
            style['left'] = '0';
        return style;
    };
    TabsComponent = __decorate([
        core_1.Component({
            selector: 'sc-tabs',
            template: "\n        <div class=\"tab-nav\">\n          <div class=\"col\" \n            *ngFor=\"let tab of tabs\"\n            [class.disabled]=\"tab.disabled\"\n            [class.active]=\"tab.act\"\n            [ngStyle]=\"{flex: tabs.length}\" \n            (click)=\"selectTab(tab, i)\">\n                {{tab.title}}\n            </div>\n            <div class=\"indicator\" [ngStyle]=\"indicatorStyle()\"></div>\n        </div>\n        <div class=\"tab-content\" [ngStyle]=\"style\">\n            <ng-content></ng-content>\n        </div>\n    ",
            styles: ["\n        :host {\n            width: 100%;\n            box-shadow: 0 2px 5px 0 rgba(0,0,0,0.16),0 2px 10px 0 rgba(0,0,0,0.12);\n            display: block;\n            border: 1px solid rgba(0, 0, 0, 0.12);\n            box-sizing: border-box;\n            color: #212121;\n        }\n        \n        .tab-nav {\n            display: flex;\n            position: relative;\n            background: #fff;\n            border-bottom: 1px solid rgba(0, 0, 0, 0.12);\n            width: 100%;\n            user-select: none;\n            -webkit-touch-callout: none;\n            -webkit-user-select: none; \n            -moz-user-select: none\n        }\n        \n        .indicator {\n            position: absolute;\n            bottom: 0;\n            height: 2px;\n            background-color: #8BC34A;\n            will-change: left, right;\n            transition: all 0.2s ease-in-out;\n        }\n        \n        .col {\n            text-align: center;\n            padding: 1rem 0.5rem;\n            cursor: pointer;\n            text-transform: uppercase;\n        }\n        \n        .col.disabled {\n            cursor: default;\n            color: #d6d6d6;\n        }\n        \n        .col.active {\n            color: #8BC34A;\n        }\n        \n        .tab-content {\n            position: relative;\n            background: #F6F6F6;\n            top: auto;\n            left: auto;\n            right: auto;\n            bottom: auto;\n            overflow: hidden;\n            transition: all 0.3s ease-in-out;\n        }\n    "]
        }), 
        __metadata('design:paramtypes', [])
    ], TabsComponent);
    return TabsComponent;
}());
exports.TabsComponent = TabsComponent;
//# sourceMappingURL=tabs.component.js.map